### HTML ROUTINES FOR THE ULTIMATE BULLETIN BOARD ##
#
# Ultimate Bulletin Board is copyright Prime Web
#
# You may freely use/modify any/all Ultimate Bulletin
# Board scripts, but you assume all liability that
# may result due to installation problems and/or
# content posted on your bulletin board.  You must also 
# keep all copyright notices on applicable pages.
#
# For more info on the Ultimate BB, 
# see http://www.prime-web.com
#
#######################################################


sub FAQ {
print<<FAQHTML;
 <HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<FONT SIZE="$TextSize" FACE="$FontFace">
<FONT SIZE="3" FACE="$FontFace" COLOR="#000080"><CENTER><B>
$BBName<BR>Frequently Asked Questions</B></FONT>
<p>
<FONT COLOR="#808000">[use your back button to return to previous page]</FONT>
</CENTER>
<p>

<TABLE BORDER=2 BGCOLOR="$ThreadsTableBGColor" width=240 align=left>
<TR>
<TD valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace">
<B><FONT SIZE="3" FACE="$FontFace" COLOR="$VisitedLinkColor"><CENTER>Definitions</CENTER></B></FONT><P>
<FONT COLOR="#800000"><B>Administrators</B></FONT><br>
Administrators have total control over every aspect of the bulletin board.  They are, in essence, the owners of the board.  
<p>
Administrators are able to set moderators for each forum, set permissions for any registered user, and edit/prune messages.
<P>
<FONT COLOR="#800000"><B>Moderators</B></FONT><BR>
Moderators are the ringleaders for each forum.  Each forum can have its own moderator, but one person may be a moderator in multiple forums.  An administrator may also be a moderator.
<p>
Moderators have the ability to edit/remove messages from their particular forum(s).  They cannot change permissions for a particular users, however.  Only administrators can change user permissions.
<P>
<FONT COLOR="#800000"><B>Members</B></FONT><BR>
Members are registered users of the bulletin board that have posted at least $MemberMinimum messages.  Members can edit their own profiles, but may not edit/remove messages, set user permissions, or assign moderators.
<P>
<FONT COLOR="#800000"><B>Junior Members</B></FONT><BR>
Junior Members are registered users who have posted fewer than $MemberMinimum messages.  Their privileges are identical to those of Members.

<P>
<FONT COLOR="#800000"><B>UBB Code</B></FONT><BR>
<A HREF="$NonCGIURL/ubbcode.html">UBB Code</A> is an HTML-like tag set that allows bulletin board writers to add additional functionality to their posts.  Current UBB Code functions include hyperlinking URLs and email addresses.
<P>
<FONT COLOR="#800000"><B>Forum</B></FONT><BR>
A Forum is a broad discussion area covering a particular interest.  Each forum may be controlled by a particular moderator assigned to lead discussion efforts and minimize abuse.
<P>
<FONT COLOR="#800000"><B>Topic</B></FONT><BR>
A Topic is a discussion point within a Forum. Any registered user can start a new Topic within a Forum.
<P>
<FONT COLOR="#800000"><B>Reply</B></FONT><BR>
A Reply is a post that is in response to an existing topic.  Any registered user can post a reply.
<P>
<FONT COLOR="#800000"><B>Thread</B></FONT><BR>
A Thread is a conversation within a forum that includes a topic (the post that started the conversation) and all replies to that topic.

</FONT>
</TD>
</table>

<TABLE BORDER=0>
<TR><TD valign=top><FONT SIZE="1" FACE="$FontFace">
<B>
<FONT COLOR="#FF0000">Can I attach files to my Topic or Reply? </FONT>
<P>
No. You may cut and paste within the input box for your Topic or Reply, however.
<P>
<FONT COLOR="#FF0000">Why should I register?</FONT>
<P>
You may only post Topics and/or Replies if you are registered.  Registration is free.
<P>
<FONT COLOR="#FF0000">
My Email address has changed since I first registered... how can I change my profile?

</FONT>
<P>
Throughout the site, you will find an "edit profile" link. Feel free to change any of your profile information (except your UserName) at any time.
<P>
<FONT COLOR="#FF0000">Can I add a bulletin board like this to my own site?</FONT>
<P>
Yes, the Ultimate Bulletin Board is freeware (a more advanced version is available as shareware) and available from Prime Web. You will need some basic knowledge of FTP in order to add the script to your site. Your web host must also allow custom scripts.
<P>
<FONT COLOR="#FF0000">How do I become a moderator for a forum?</FONT>
<P>

Only the bulletin board administrator can control the assignment of moderators. Contact the BB administrator if you would like more
information.
<P>
<FONT COLOR="#FF0000">What can moderators do?</FONT>
<P>
They cannot restrict member access to boards, though they can appeal to
the administrator to have a member's posting priviledge revoked.
<P>
<FONT COLOR="#FF0000">I've just seen a post that was very offensive. Is there anything I can do about it?</FONT>
<P>
You should contact the Forum Moderator and tell them which particular Topic or Topic Reply you found offensive. If necessary, they have the
ability to delete or edit a post.
<P>
<FONT COLOR="#FF0000">Can I incorporate HTML in my posts?</FONT>
<P>
Maybe.  Each forum can be independently configured to either allow HTML tags or not. (This is determined by the bulletin board administrators).  Whenever you post a new topic or reply in a forum, you will see a note near the top of the page saying that HTML is either enabled or not enabled.
<P>
Even if HTML is not enabled, you will still be able to perform certain HTML-like function, however, using <A HREF="$NonCGIURL/ubbcode.html">UBB Code</A>, an HTML-like tag set that allows for certain basic functions like hyperlinking URLS and email addresses.  
<P>
<FONT COLOR="#FF0000">Who is responsible for this Bulletin Board?</FONT>
<P>
The BB administrators have total control over the content of this bulletin board.  Although the code for this BB was created by <A HREF="http://www.prime-web.com">Prime Web</A>, Prime Web is not responsible for the content contained in the BB nor any negative ramifications associated with the operation of the BB.  <A HREF="http://www.prime-web.com">Prime Web</A> has made this bulletin board program available at no cost to anyone who wants it.  The BB administrators/owners assume total liability for this BB. 
</font></B></td></table>
<p>
<CENTER><FONT COLOR="#808000">[use your back button to return to previous page]</FONT></CENTER>
<p><CENTER>
<FONT COLOR="#C0C0C0" size="1">Powered by: <A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3</A><BR>&copy; Madrona park, Inc., 1998.
<br>
<br>
</CENTER>
</FONT>
</BODY></HTML>
FAQHTML
}

## END FAQ SUBROUTINE

sub ForumsTopHTML {
print <<INTROHTML;
<HTML>
<HEAD><TITLE>Ultimate Bulletin Board Freeware Version A-3 : $BBName</title>
<META HTTP-EQUIV="refresh" CONTENT="180; URL='$CGIURL/Ultimate.cgi?action=intro'">
</head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<FONT FACE="$FontFace" SIZE="$TextSize">
<table border=0 width=600>
<tr>
<TD>
<CENTER>
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0>
</CENTER>
</td>
<td>
<CENTER>
<B><FONT SIZE="3" FACE="$FontFace" COLOR="#800000">$BBName</FONT></B>
<br><FONT SIZE="1" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune">edit profile</A> | <A HREF="$CGIURL/Ultimate.cgi?action=register">register</A> | <A HREF="$CGIURL/Ultimate.cgi?action=faq">help/faq</A>
</FONT>
</CENTER>
</td>
</table>
<table border=0>
<tr bgcolor="$TableColorStrip">
<td width=55% valign=bottom>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">Forum</FONT>
</td>
<td width=10% valign=bottom>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">Posts</FONT>
</td>
<td width=20% valign=bottom>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">Last</FONT>
</td>
<td width=15% valign=bottom>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">Moderator</FONT>
</td>
INTROHTML
}  ## END FORUMS TOP HTML

sub ForumsGutsHTML {
print <<ForumSummary;
<TR><TD BGCOLOR=$AltColumnColor1 width=55% valign=top><FONT SIZE="2" FACE="$FontFace"><B>
<A HREF="$CGIURL/Ultimate.cgi?action=topics&forum=$ForumCoded&number=$x&DaysPrune=20&Browser=other">
$ForumName</A></B><br>$ForumDesc<br></FONT>
</td><td BGCOLOR=$AltColumnColor2 width=10% valign=top>
<FONT SIZE="2" FACE="$FontFace">$numberOfPosts</FONT>
</td><td BGCOLOR=$AltColumnColor1 width=20% valign=top>
<FONT SIZE="2" FACE="$FontFace">$Month-$Day-$Year</FONT>
</td><td width=15% BGCOLOR=$AltColumnColor2 valign=top>
<FONT SIZE="2" FACE="$FontFace">$Moderator</FONT></td>
ForumSummary
}  ## END FORUMS GUTS HTML

sub ForumsBottomHTML {
print <<BOTTOMhtml;
</table>
<P>
<CENTER>
<FONT COLOR="#800000"><A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL">$MyHomePage</A></FONT>
<p>
<FONT COLOR="#C0C0C0" size="1">
<br>Powered by: 
<A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3 </A><BR>&copy; Madrona Park, Inc., 1997, 1998.
<br>
<br>

</FONT>
</CENTER>
</FONT>
</body></html>
BOTTOMhtml
}  ## END Forums Bottom HTML subroutine

sub TopicTopHTML {
print <<TOP;
<HTML>
<HEAD><TITLE>Ultimate Bulletin Board Freeware Version A3- $BBName</title>
</head>
 <BODY BGCOLOR="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor" topmargin=0>
<b><FONT SIZE="$TextSize" FACE="$FontFace">
TOP
}  ## END TOPIC TOP HTML sr

sub TopicMidNonIEhtml {
print <<OtherMiddle;
<table border=0>
<tr>
<td width=300 align=left valign=top>
<IMG SRC="$NonCGIURL/$BBTitle" BORDER=0>
<BR>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$LinkColor"><B>$Forum</B>
<br><FONT size= "1" COLOR="$VisitedLinkColor">(moderated by <A HREF="mailto:$ModeratorEmail">$Moderator</A>)</FONT>
</FONT>
</td>
<td width=300 valign=top><FONT SIZE="1" FACE="$FontFace">
<BLOCKQUOTE>
<IMG SRC="$NonCGIURL/open.gif" WIDTH=15 HEIGHT=11 BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro">$BBName</A>
<br>
<IMG SRC="$NonCGIURL/tline.gif" WIDTH=12 HEIGHT=12 BORDER=0><IMG SRC="$NonCGIURL/open.gif" WIDTH=15 HEIGHT=11 BORDER=0>&nbsp;&nbsp;$Forum
</BLOCKQUOTE>
<center>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=newtopic&number=$number&forum=$ForumCoded&Browser=$Browser&DaysPrune=$DaysPrune"><IMG SRC="$NonCGIURL/$BBTopic"  BORDER=0 ALT="Post New Topic"></A></FONT>
<BR>
<A HREF="$CGIURL/Ultimate.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune">edit profile</A> | <A HREF="$CGIURL/Ultimate.cgi?action=register">register</A> | <A HREF="$CGIURL/Ultimate.cgi?action=faq">help/faq</A>
</center>
<p>
<FORM ACTION="Ultimate.cgi" NAME="PruneForm" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="topics">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<INPUT TYPE="HIDDEN" NAME="Browser" VALUE="$Browser">
<SELECT NAME="DaysPrune">
	<OPTION value="1" $Days1>Show topics from last day
	<OPTION value="2" $Days2>Show topics from last 2 days
	<OPTION value="5" $Days5>Show topics from last 5 days
	<OPTION value="10" $Days10>Show topics from last 10 days
	<OPTION value="20" $Days20>Show topics from last 20 days
	<OPTION value="30" $Days30>Show topics from last 30 days
	<OPTION value="45" $Days45>Show topics from last 45 days
	<OPTION value="60" $Days60>Show topics from last 60 days
	<OPTION value="75" $Days75>Show topics from last 75 days
	<OPTION value="100" $Days100>Show topics from last 100 days
</SELECT>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Go">
</FORM>

</FONT>
</td></table>

<table border=0>
<tr bgcolor="$TableColorStrip">
<td>
<FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor">Topic</FONT>
</td>
<td>
<FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor">Originator</FONT>
</td>
<td><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor">Replies</FONT>
</td>
<td NOWRAP><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor">Last Post</FONT>
</td>
OtherMiddle
}  ## END Middle HTML for Topic Page (Non-Internet Explorer version)

sub TopicGutsNonIEhtml {
print <<GUTS;
<TR>
<TD BGCOLOR="$AltColumnColor1">
<IMG SRC="$NonCGIURL/closed.gif" WIDTH=14 HEIGHT=11>
<FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=threadlist&forum=$ForumCoded&number=$number&topic=$topic&Browser=$Browser&DaysPrune=$DaysPrune">$subject</A>
</FONT>
</td>
<td BGCOLOR="$AltColumnColor2">
<FONT SIZE="$TextSize" FACE="$FontFace">$author</FONT>
</td>
<td align=center BGCOLOR="$AltColumnColor1">
<FONT SIZE="$TextSize" FACE="$FontFace">$RepliesFormat</FONT>
</td>
<td NOWRAP BGCOLOR="$AltColumnColor2">
<FONT SIZE="$TextSize" FACE="$FontFace">$Month-$Day-$Year <FONT SIZE="1" FACE="$FontFace" COLOR="#008080">$settime</FONT></FONT>
</td>
GUTS
}  ## END Guts HTML for Topic Page (Non IE version)


sub TopicBottomNonIEhtml {
print<<BOTTOM
</table>
<br>
<table border=0 width=600>
<tr><td align=left valign=top>
<FONT SIZE="1" FACE="$FontFace" COLOR="#FF0000">Note: all times are $TimeZone</FONT></td>
BOTTOM
} ## End TopicBottomNonIEhtml

sub TopicBottom2NonIEhtml {
print<<TrueTopicBottom;
</TABLE>
<P><CENTER><B>
<A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL">$MyHomePage</A>
</B>
</CENTER><P><BR>
<center><FONT SIZE="1" FACE="$FontFace" COLOR="#C0C0C0">Powered by: 
<A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3</A><BR>&copy; Madrona Park, Inc., 1997, 1998.
<br>
<br>

</FONT>
</center>
</body></html>
TrueTopicBottom
}
sub ThreadTopHTML {
print <<TOP;
<HTML>
<HEAD><TITLE>$BBName</title>
</head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<b><FONT SIZE="$TextSize" FACE="$FontFace">

<table border=0><TR>
<td valign=top align=left width=300>
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0>
<BR>
</FONT>
</td>
<td width=300 valign=top>
<FONT SIZE="1" FACE="$FontFace">
<BLOCKQUOTE>
<IMG SRC="$NonCGIURL/open.gif" WIDTH=15 HEIGHT=11 BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro">$BBName</A>
<br>
<IMG SRC="$NonCGIURL/tline.gif" WIDTH=12 HEIGHT=12 BORDER=0><IMG SRC="$NonCGIURL/open.gif" WIDTH=15 HEIGHT=11 BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=topics&forum=$ForumCoded&number=$number&DaysPrune=$DaysPrune&Browser=$Browser">$Forum</A>
<br>
<IMG SRC="$NonCGIURL/tline3.gif" WIDTH=24 HEIGHT=12 BORDER=0><IMG SRC="$NonCGIURL/open.gif" WIDTH=15 HEIGHT=11 BORDER=0>&nbsp;&nbsp;$TopicSubject
</BLOCKQUOTE>
<center>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=newtopic&number=$number&forum=$ForumCoded&Browser=$Browser&DaysPrune=$DaysPrune"><IMG SRC="$NonCGIURL/$BBTopic"  BORDER=0 ALT="Post New Topic"></A>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=reply&forum=$ForumCoded&number=$number&topic=$topic&TopicSubject=$SubjectCoded&Browser=$Browser&DaysPrune=$DaysPrune "><IMG SRC="$NonCGIURL/$BBReply"  BORDER=0 ALT="Post A Reply"></A></FONT>
<BR>
<A HREF="$CGIURL/Ultimate.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune">edit profile</A> | <A HREF="$CGIURL/Ultimate.cgi?action=register">register</A> | <A HREF="$CGIURL/Ultimate.cgi?action=faq">help/faq</A>
</center>
</td></table>
TOP
}  ## END Thread Top HTML sr

sub ThreadGutsNonIEhtml {

print<<otherHTML;
<table width=600 bgcolor="$ThreadsTableBGColor" border=0 cellpadding=10>
<tr>
<td width=150 valign=top>
<FONT SIZE="$TextSize" face="$FontFace" COLOR="#000000"><B>$topicguts[0]</B></FONT>
<BR>
<FONT SIZE="1" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=getbio&UserName=$UNCoded">profile</A> | <A HREF="mailto:$topicguts[4]">email</A>
</FONT>
</td>
<td width=450 valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FONT SIZE="1" color="#008080" face="$FontFace">posted $topicguts[1] $topicguts[2] $TimeZone</FONT><br><B>$topicguts[5]</B>
</FONT>
</td>
otherHTML
}  ## Guts HTML for Threads page (non Internet Explorer version)

sub ThreadRepliesNonIEhtml {

print <<REPLYhtml;
<tr>
	<TD width=150 valign=top>
	<FONT SIZE="$TextSize" face="$FontFace" COLOR="#000000"><B>$replyguts[0]</B></FONT>
<BR>
<FONT SIZE="1" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=getbio&UserName=$UserNameCoded">profile</A> | <A HREF="mailto:$replyguts[4]">email</A>
</FONT>
</td>
<td width=450 valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace">
<FONT SIZE="1" color="#008080" face="$FontFace">posted $replyguts[1] $replyguts[2] $TimeZone</FONT><br><B>$replyguts[5]</B>
</FONT>
</td>
REPLYhtml
}  ## END Replies within Thread page (non IE version)

sub ThreadBottomNonIEhtml {
print<<BOTTOM;
</table>
<p>
BOTTOM
} #END ThreadBottomNonIEhtml sr

sub ThreadBottom2NonIEhtml {
print<<Bottom2;
<CENTER><B><FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL">$MyHomePage</A>
</B></FONT>
<p><BR><FONT SIZE="1" FACE="$FontFace" COLOR="#C0C0C0">Powered by: 
<A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3</A><BR>&copy; Madrona Park, Inc., 1997, 1998.
<br>
<br>

</FONT>
</center>
</body></html>
Bottom2
}  ## END bottom of Threads page (non IE Version)


sub ReplyFormHTML {
print <<REPLYFORM;
<HTML><HEAD>
</HEAD>
 <BODY BGCOLOR="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<table border=0>
<TR><TD>
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0></td>
<td valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace" color="#000080">
<B>
Forum: <FONT COLOR="#008080">$Forum </FONT>
<BR>
Topic: <FONT COLOR="#008080">$TopicSubject</FONT>
</B>
</FONT>
<p>
<CENTER><FONT SIZE="1" FACE="$FontFace" COLOR="#000080">
$ISHTML
</CENTER>
</td></table>

<ul>
<FORM ACTION="Ultimate.cgi" NAME="REPLIER" METHOD="POST">
<table border=0>
<tr><td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#000080">Your UserName:</FONT></td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=25 MAXLENGTH=25>
</td>
</tr>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#000080">Your Password:</FONT></td>
<td><INPUT TYPE="PASSWORD" NAME="Password" VALUE=""  SIZE=13 MAXLENGTH=13>
</td>
<TR><TD valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#000080">Your Reply:</FONT></td>
<td>
<TEXTAREA NAME="ReplyMessage" ROWS=10 COLS=45 WRAP="VIRTUAL"></TEXTAREA>
</td>
</table>
<p>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="postreply">
<INPUT TYPE="HIDDEN" NAME="TopicSubject" VALUE="$TopicSubject">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<INPUT TYPE="HIDDEN" NAME="topic" VALUE="$topic">
<INPUT TYPE="HIDDEN" NAME="Browser" VALUE="$Browser">
<INPUT TYPE="HIDDEN" NAME="DaysPrune" VALUE="$DaysPrune">
<INPUT TYPE="HIDDEN" NAME="HTMLAllowed" VALUE="$HTMLAllowed">
<CENTER>
 <FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Note: You must be registered in order to post a topic or reply. <br>
To register, <A HREF="$CGIURL/Ultimate.cgi?action=register">click here</A>.</font>
<p>
<INPUT TYPE="Submit" NAME="SUBMIT" VALUE="Submit Reply">
<INPUT TYPE="RESET" NAME="RESET" VALUE="Clear Fields">
</form>
<P>
<FONT SIZE="1" FACE="$FontFace" COLOR="#FF0000">*If HTML is enabled, this means you can use use HTML tags in your message (you may also use <A HREF="$NonCGIURL/ubbcode.html" target=_new>UBB Code</A> as well).  If HTML is not enabled, you may not use HTML, but you may use <A HREF="$NonCGIURL/ubbcode.html" target=_new>UBB Code</A> in your message.</FONT>
</center>
<br></ul><center>
REPLYFORM
} # end ReplyFormHTML

sub ReplyFormBottom {
print<<REPLYFORMBOTTOM
</table>
<P>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">
<CENTER><B>
<A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL">$MyHomePage</A>
</B></FONT>
<FONT SIZE="1" FACE="$FontFace" COLOR="#C0C0C0">
<br><br><br><B>Powered by: <A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3</A><br>&copy;Madrona Park, Inc., 1998.
</FONT></B></CENTER>
</BODY></HTML>
REPLYFORMBOTTOM
}  ## END Reply Form Bottom sr

sub ReplyConfirmHTML {
print <<CONFIRM;
<HTML><HEAD>
<meta http-equiv="Refresh" content="3; URL=Ultimate.cgi?action=threadlist&forum=$ForumCoded&number=$number&Browser=$Browser&DaysPrune=$DaysPrune&topic=$newFileName">
</HEAD>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808000">
<B>Thanks for posting your message, $UserName!  We are now sending you back automatically to the thread list for this topic.  Please wait three seconds.
</B><br><br>
</FONT>
</ul></body></html>
CONFIRM
}  ## END Reply Confirmation HTML

sub PermissionDeniedHTML {
print<<NoPermission;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<FONT SIZE="$TextSize" FACE="$FontFace">
<BR><BR><B><ul>
Sorry, but you no longer have permission to post a note on the bulletin board.  Either the administrator of the BB or one of the moderators has removed your posting priviledges.
</B></UL></FONT>
</body></HTML>
NoPermission
}  ## END Permission Denied HTML sr

sub TopicFormHTML {
print <<FORM;
<HTML>
<HEAD>
</HEAD>
 <BODY BGCOLOR="$BGColor" text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<table border=0>
<TR><TD>
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">
<B>Post New Topic for Forum:<br>&nbsp;&nbsp;&nbsp;<FONT COLOR="#808000">$Forum</FONT></FONT></B>
<p>
<CENTER><FONT SIZE="1" FACE="$FontFace" COLOR="#000080">
$ISHTML
</FONT>
</td></table>
<p>
<ul>
<FORM ACTION="Ultimate.cgi" METHOD="POST" NAME="PostTopic">
<table border=0>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808080"><B>Your UserName:</B></FONT></td><td><INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808080"><B>Your Password:</B></FONT></td><td><INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13></td></tr>
<TR>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808080"><B>Subject:</B></FONT></td>
<td><INPUT TYPE="TEXT" NAME="TopicSubject" VALUE="" SIZE=40 MAXLENGTH=120></td>
<tr><td valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808080"><B>Message:</B></FONT></td>
<td>
<TEXTAREA NAME="Message" ROWS=6 COLS=45 WRAP="VIRTUAL">
</TEXTAREA></td></table>
<BR><BR>
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="posttopic">
<INPUT TYPE="HIDDEN" NAME="Browser" VALUE="$Browser">
<INPUT TYPE="HIDDEN" NAME="DaysPrune" VALUE="$DaysPrune">
<INPUT TYPE="HIDDEN" NAME="HTMLAllowed" VALUE="$HTMLAllowed">
<CENTER>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit New Topic">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Clear Fields">
</form></center>
<br></ul>
<FONT SIZE="1" FACE="$FontFace" COLOR="#FF0000">*If HTML is enabled, this means you can use use HTML tags in your message (you may also use <A HREF="$NonCGIURL/ubbcode.html" target=_new>UBB Code</A> as well).  If HTML is not enabled, you may not use HTML, but you may use <A HREF="$NonCGIURL/ubbcode.html" target=_new>UBB Code</A> in your message.</FONT>
<P>
<center>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Note: You must be registered in order to post a topic or reply. <br>
To register, <A HREF="$CGIURL/Ultimate.cgi?action=register">click here</A>.<BR><br>
<B>
<A HREF="mailto:$BBEmail">Contact Us</A> | <A HREF="$HomePageURL">$MyHomePage</A>
</B>
</FONT>
<p>
<FONT SIZE="1" FACE="$FontFace" color="#C0C0C0">Powered by: <A HREF="http://www.UltimateBB.com">Ultimate Bulletin Board, Freeware Version A-3</A><br>&copy;Madrona Park, Inc., 1998</FONT>
</CENTER>
</ul>
</BODY></HTML>
FORM
}  ## END Topic Form HTML

sub TopicConfirmHTML {
print <<Confirm;
<HTML>
<HEAD>
<meta http-equiv="Refresh" content="3; URL=Ultimate.cgi?action=topics&forum=$ForumCoded&number=$number&DaysPrune=$DaysPrune&Browser=$Browser">
</HEAD>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808000">
<B>Thanks for posting your message, $UserName!  We are now taking you back automatically to the topic list for $Forum.  Please wait two seconds.
</B><br><br>

</FONT>
</ul></body></html>
Confirm
}  ## END Topic Confirmatin HTML

sub ViewBioHTML {

print <<BioHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#000080"><B>Profile for $thisprofile[0]</B></FONT>
<p>
<BLOCKQUOTE>
<table border=0>
<tr><td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Status:</FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$thisprofile[8]</FONT>
</td>
<tr><td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Total Posts:</FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$thisprofile[7]</FONT>
</td>
<tr><td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Current Email:</FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080"><A HREF="mailto:$thisprofile[2]">$thisprofile[2]</A></FONT>
</td>
<TR>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Homepage:</font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080"><A HREF="$thisprofile[3]" target=_top>$thisprofile[3]</A></font>
</td>
<TR>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Occupation:</font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$thisprofile[5]</font>
</td>
<TR>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Location:</font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$thisprofile[6]</font>
</td>
<TR>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">Interests:</font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$thisprofile[9]</font>
</td>
</table>
</BLOCKQUOTE>
<FONT SIZE="$TextSize" FACE="$FontFace"><B><center>
Use your back button to return to the previous page.
</center>

</B></FONT>
</BODY></HTML>
BioHTML
}  ## END View BIO HTML sr


sub EditBio {
print<<EDITbioHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0>
<FONT SIZE="3" FACE="$FontFace" COLOR="#000080"><B>Modify Your Profile</B></FONT>
<p><FONT SIZE="$TextSize" FACE="$FontFace">
It is your responsibility to keep your profile information up-to-date.  Do not ask the administrator or moderators to do this for you.
<p>
To modify your current profile information, please identify yourself below.
</FONT>
<p>
<FORM ACTION="Ultimate.cgi" METHOD="POST">
<table border=0>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>UserName</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Password</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td>
</table>
<center>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="checkbioid">
<INPUT TYPE="HIDDEN" NAME="Browser" VALUE="$Browser">
<INPUT TYPE="HIDDEN" NAME="DaysPrune" VALUE="$DaysPrune">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Identification">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Clear Fields">
</center>

</form>
</BODY></HTML>
EDITbioHTML

}  ##END EDIT BIO SR

sub BioModifyConfirmHTML {
print<<HTML;
<HTML>
<HEAD><TITLE>
Member Profile Modification Confirmation</title>

</head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor"><BR><BR>
<p><FONT SIZE="$TextSize" FACE="$FontFace"><B>
Thank you, $UserName.  Your profile has been successfully updated.
<P>
<table border=0>
<TR>
<TD valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Return to:</B></FONT></td>
<td valign=top>
	<A HREF="Ultimate.cgi">$BBName</A><BR>
	<A HREF="Ultimate.cgi?action=editbio&Browser=other&DaysPrune=$DaysPrune">Edit Your Profile</A><BR>
<A HREF="Ultimate.cgi?action=faq">Help/FAQ</A>
</td></table>
</B>
</FONT>
</body>
</html>
HTML
}  ## END Bio Modify Confirmation sr

sub ProcessEdit {
print<<EditHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0>
<FONT SIZE="3" FACE="$FontFace" COLOR="#000080"><B>Modify Your Profile</B></FONT>
<p><FONT SIZE="$TextSize" FACE="$FontFace">
Thank you! We have confirmed your identity, $UserName ($Status).
<p>
Feel free to modify any of the fields below.
<p>
</FONT>
<FORM ACTION="Ultimate.cgi" METHOD="POST">
<table border=0>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Email Address</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Email" VALUE="$Email" SIZE=30 MAXLENGTH=155>
</td>
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Password</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="NewPassword" VALUE="$Password" SIZE=30 MAXLENGTH=155>
</td>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Homepage</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="URL" VALUE="$URL" SIZE=30 MAXLENGTH=200>
</td>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Occupation</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Occupation" VALUE="$Occupation" SIZE=30 MAXLENGTH=100>
</td>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">City, State, Country</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Location" VALUE="$Location" SIZE=30 MAXLENGTH=150>
</td>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Interests</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Interests" VALUE="$Interests" SIZE=50 MAXLENGTH=200>
</td>
</table>
<center>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="modifybio">
<INPUT TYPE="HIDDEN" NAME="UserName" VALUE="$UserName">
<INPUT TYPE="HIDDEN" NAME="Password" VALUE="$in{'Password'}">
<INPUT TYPE="HIDDEN" NAME="Permissions" VALUE="$Permissions">
<INPUT TYPE="HIDDEN" NAME="Status" VALUE="$Status">
<INPUT TYPE="HIDDEN" NAME="TotalPosts" VALUE="$TotalPosts">
<INPUT TYPE="HIDDEN" NAME="Browser" VALUE="$Browser">
<INPUT TYPE="HIDDEN" NAME="DaysPrune" VALUE="$DaysPrune">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Modifications">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Clear Fields">
</center>
</form>
</BODY></HTML>
EditHTML
}  ##END Process Edit SR

sub Register {
print<<RegHTML;
<HTML>
<HEAD>
	<TITLE>Ultimate Bulletin Board Registration</TITLE>
</HEAD>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<IMG SRC="$NonCGIURL/$BBTitle"  BORDER=0>
<FONT SIZE="3" FACE="$FontFace" COLOR="#000080"><B>
Bulletin Board Registration

</B></FONT>
<P>
<table border=0>
<tr>
<td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace">
<B>In order to post messages on this Bulletin Board, you must first register.  
<BR><BR>
UserNames can be up to 25 characters and passwords can be a maximum of 13 characters.  Please use only letters and numbers.  Passwords are case-sensitive.  This means that "Howard" is distinct from "HOWARD."  
<BR><BR>
Note: all of the information provided on this page (with the exception of your password) will be viewable by anyone visiting the bulletin board.  Thus, if you don't feel comfortable about completing certain fields, just leave them blank.  In addition, your passwords are not encrypted and can be seen by the BB administrators.  Required fields are marked by an asterisk.
<br><br></B></FONT>
</td>
<tr>
<FORM NAME="Register" METHOD=POST ACTION="Ultimate.cgi">

<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>User Name*</B></FONT></TD>
<TD><INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=25 MAXLENGTH=25>
 </TD>
</TR>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Password*</B></FONT></TD>
	<TD><INPUT TYPE="PASSWORD" NAME="Password" VALUE="" SIZE=13 MAXLENGTH=13>
 </TD>
</TR>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Enter Password Again*</B></FONT></TD>
	<TD><INPUT TYPE="PASSWORD" NAME="PasswordConfirm" VALUE="" SIZE=13 MAXLENGTH=13>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Email*</B></FONT></TD>
	<TD><INPUT TYPE="TEXT" NAME="Email" VALUE="" SIZE=30 MAXLENGTH=50>
 </TD>
</TR>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>City, State, Country</B></FONT></TD>
	<TD><INPUT TYPE="TEXT" NAME="Location" VALUE="" SIZE=30 MAXLENGTH=50>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Occupation</B></FONT></TD>
	<TD><INPUT TYPE="TEXT" NAME="Occupation" VALUE="" SIZE=30 MAXLENGTH=50>
 </TD>
</TR>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Homepage</B></FONT></TD>
	<TD><INPUT TYPE="TEXT" NAME="URL" VALUE="http://" SIZE=30 MAXLENGTH=100>
 </TD>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Interests</B></FONT></TD>
	<TD><INPUT TYPE="TEXT" NAME="Interests" VALUE="" SIZE=30 MAXLENGTH=200>
 </TD>
</TABLE><BR><BR><CENTER>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="RegSubmit">

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Reset">

</CENTER></FORM>
<BR><BR><BR>.</BODY>
</HTML>
RegHTML


}  ## END Register SR ##

sub IllegalNameHTML {
print<<Illegal;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<BR><BR>
<FONT SIZE="$TextSize" FACE="$FontFace">You have included an illegal character in your UserName.  Please go back and enter a new UserName.  Please only use numbers, letters, or spaces.  Thank you!
<p><CENTER>
[Use your back button to try again]
</CENTER>
</FONT>
</BODY></HTML>
Illegal

}  ## END Illegal name sr



sub PrintRegistrationHTML {
print <<HTML;
<HTML>
<HEAD><TITLE>
User Registration Confirmation</title></head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<table border=0>
<tr><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Congratulations!
<P>
You have successfully registered your User Name and Password for $BBName.  Feel free to post messages on any of our forums.  Your registration information is listed below.</B></FONT>
</td>
<tr>

<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#000000"><B>User Name</B></FONT></TD>
<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$UserName</font>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Password</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$in{'Password'}</font>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Email</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$Email</font>
 </TD>
</TR>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>City, State, Country</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$Location</font>
 </TD>
</TR>
<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Occupation</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$Occupation</font>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Interests</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$Interests</font>
 </TD>

<TR>
	<TD bgcolor="#C0C0C0"><FONT SIZE="$TextSize" FACE="Arial" COLOR="#000000"><B>Homepage</B></FONT></TD>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#008080">$URL</font>
 </TD>
</TABLE>
<p><FONT SIZE="$TextSize" FACE="$FontFace">
<A HREF="$CGIURL/Ultimate.cgi?action=intro">Click here to enter the Bulletin Board now!</A><br><br>
</FONT>
<br><br><br><br>.</body>
</html>
HTML
} ## END Print Registration sr


sub GoBack {
print <<GoBackText;
<HTML>
<HEAD><TITLE>
User Registration Attempt Failed</title></head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<ul>
<table border=0>
<tr>
<td bgcolor="#800000">
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#FFFFFF"><B>Registration Failed!</B></font> </td>
<tr>
<td>
<font SIZE="$TextSize" face="$FontFace"><B>You failed to type the same password twice on the registration form.  Please go back and try again.
<br><br>
<A HREF="$CGIURL/Ultimate.cgi?action=register">Click here</A> to go back.
</B></font></td></table>
<BR><BR><BR>.
</body></html>
GoBackText
} #end GoBack subroutine


sub Duplicate {
print <<Sorry_HTML;
<HTML>
<HEAD><TITLE>
User Registration Attempt Failed</title></head>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<ul>
<table border=0>
<tr><td>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#800000"><B>Registration Failed!</B></font> </td>
<tr><td>
<font SIZE="$TextSize" face="$FontFace"><B>The User Name and/or the email address you listed have already been reserved by someone else.  Please choose another User Name and/or email address.
<br><br>
<A HREF="$CGIURL/Ultimate.cgi?action=register">Click here</A> to return to the Registration Screen.
</B></font></td></table></ul>
<br><br>.
</body>
</html>

Sorry_HTML
}


sub NoMatch {
print <<NoMatchHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<br><BR>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808000">
Sorry, you supplied a UserName that is not registered.  If you have never registered before, <A HREF="$CGIURL/Ultimate.cgi?action=register">please do so now</A>.  Registration is free.
</FONT>
<p>

</BODY></HTML>
NoMatchHTML
}

sub WrongPassword {
print <<WrongHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<br><BR>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="#808000">Sorry, the password you supplied is incorrect.  Please use your back button to try again!</FONT>
<p>
</BODY></HTML>
WrongHTML
}


sub MissingFields {
print <<WrongHTML;
<HTML>
 <BODY BGCOLOR="$BGColor"  text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<br><BR><BLOCKQUOTE>
<FONT SIZE="$TextSize" FACE="$FontFace">Sorry, but you failed to complete all required fields.  This error message will also be returned if you failed to return a properly formatted email address. Please use your back button to try again!</FONT></BLOCKQUOTE>
<p>
</BODY></HTML>
WrongHTML
}


1; #return true 

