########################
# "Reconfigure" Screen #
########################

$text{'5000'} = 
"(<STRONG>&quot;Chronological&quot;</STRONG> displays show messages simply in the order in which they were posted; <STRONG>&quot;threaded&quot;</STRONG> displays show messages in indented lists, with responses directly beneath their parent messages. In either style, a normal list puts the newest messages at the bottom, while a reversed list, obviously, does the reverse. The <STRONG>&quot;reversed theaded&quot;</STRONG> display, though somewhat awkward, is the &quot;default&quot; index style of many Web-based bulletin boards, including Matt Wright's &quot;WWWBoard&quot; script, and is the style with which many users are most familiar. The <STRONG>&quot;mixed threaded&quot;</STRONG> display is a bit of a half-breed; it arranges primary messages with the newest at the top, thus tending to keep newer messages toward the top of the page, but arranges responses with the newest at the bottom, thus preserving a more &quot;intuitive&quot; threading structure. <STRONG>&quot;Compressed&quot;</STRONG> displays show on the main index page only the first message of each thread; responses are available only by going to the primary message's page. This keeps the index page a bit smaller, but also, of course, makes the responses a bit more difficult to access. Finally, <STRONG>&quot;guestbook-style&quot;</STRONG> displays show the full text of messages on the main index page in a strict chronological manner; <STRONG>&quot;threaded guestbook-style&quot;</STRONG> displays show an index page very similar to that of the &quot;compressed&quot; displays, but show the full text of all messages in a thread on a single page.)";

##################
# E-Mail Notices #
##################

$text{'7000'} =
"The following new message has been posted on the <!--boardname--> at <<!--boardurl-->>.";

$text{'7001'} =
"***************************************************************************";

$text{'7002'} =
"This is an automatically-generated notice.  If you'd like to be removed from the mailing list, please visit the <!--boardname--> at <<!--boardurl-->>, or send your request to <!--email-->.";

$text{'7003'} =
"If you wish to respond to this message, please post your response directly to the board.  Thank you!";

$text{'7500'} =
"The following new messages have been posted on the <!--boardname--> at <<!--boardurl-->>.";

##################
# Error Messages #
##################

$text{'9100'} =
"No Message!";

$text{'9101'} =
"Sorry, but the message you just tried to load doesn't exist! You may have followed an obsolete hard-coded link, or it may be that you just tried to enter the address manually, and mis-typed it.";

$text{'9200'} =
"Incomplete Submission!";

$text{'9201'} =
"Your message is incomplete! Your enthusiasm is appreciated, but you need to make sure that you include <EM>your name</EM>, <EM>a subject line</EM> and (of course) <EM>a message</EM>! Please return to the entry form and try again. Thanks! (If you use the &quot;Back&quot; button on your browser, any information you've already input should be retained.)";

$text{'9250'} =
"Message Too Long!";

$text{'9251'} =
"Your message is longer than is allowed on this board! It may be that you included too much quoted material, or it may just be that you had too much to say! In either event, please return to the entry form and try to reduce the verbiage. Thanks! (If you use the &quot;Back&quot; button on your browser, any information you've already input should be retained.)";

$text{'9300'} =
"Invalid Address!";

$text{'9301'} =
"Thanks for your interest, but the e-mail address you entered seems to be invalid. Please use the &quot;Back&quot; button on your browser to return and re-enter it.";

$text{'9400'} =
"File Error!";

$text{'9401'} =
"The server encountered a file error! This most likely means either that the data directory's location has been incorrectly defined or that its permissions have been incorrectly set.";

$text{'9410'} =
"File Lock Error!";

$text{'9411'} =
"The server encountered a file lock error! This most likely means either that the data directory's location has been incorrectly defined or that its permissions have been incorrectly set, or that the flock() command is not supported, in which case the script's $UseLocking configuration variable should be set to 0.";

$text{'9450'} =
"Mail System Error!";

$text{'9451'} =
"The server encountered an error while trying to send out e-mail notifications. This most likely means that the e-mail program has been incorrectly defined in the program's configuration.";

$text{'9500'} =
"Duplicate Submission!";

$text{'9501'} =
"This error usually means that you have pressed the &quot;Post Message&quot; button more than once for the same message. If that's the case, then your message has probabably already been posted. The error could also mean that you &quot;previewed&quot; your message, but then went back to the main input form and tried to submit it from there without making any changes. If that's the case, simply go back, make a minor change, and resubmit it!";

$text{'9600'} =
"Invalid Password!";

$text{'9601'} =
"Either your password was incorrect or no password was entered. Without a proper password, messages may not be deleted. Please use the &quot;Back&quot; button on your browser to return and try again.";

$text{'9700'} =
"Duplicate Address Submission!";

$text{'9701'} =
"Thanks for your interest, but your e-mail address is already on the e-mail notification list! You don't really need <EM>two</EM> notices of each new post, do you?";

$text{'9750'} =
"Invalid Address Submission!";

$text{'9751'} =
"Your e-mail address can't be removed from the e-mail notification list, since it is not currently <EM>on</EM> the list!";

$text{'9800'} =
"You're On The List!";

$text{'9801'} =
"Your e-mail address has been added to the e-mail notification list. Whenever a new message is posted, you'll know about it!";

$text{'9850'} =
"You're Off The List!";

$text{'9851'} =
"Your e-mail address has been removed from the e-mail notification list.";

$text{'9999'} =
"If you have any questions, please send a note to <!--emaillink-->.";

1;

