############################################
##                                        ##
##          WebAdverts (Display)          ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version:  1.52             ##
##         last modified: 2/13/98         ##
##           copyright (c) 1998           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

# NOTHING BELOW THIS LINE NEEDS TO BE ALTERED!

sub ADVsetup {
	$AdvertChosen = 0;
	if ((-e "$adverts_dir/adcount.txt") && !(-e "$adverts_dir/adlist.txt")) {
		&UpdateAdList;
	}
	$ADVtime = time;
	($ADVmin,$ADVhour,$ADVmday,$ADVmon,$ADVyear) =
	  (localtime($ADVtime))[1,2,3,4,5];
	if ($ADVmin < 10) { $ADVmin = "0$ADVmin"; }
	if ($ADVhour < 10) { $ADVhour = "0$ADVhour"; }
	if ($ADVmday < 10) { $ADVmday = "0$ADVmday"; }
	$ADVmon++;
	if ($ADVmon < 10) { $ADVmon = "0$ADVmon"; }
	$ADVyear = $ADVyear+1900;
	$ADVshown = 0;
	$ADVWrapCounter = 0;
	unless ($advertzone) { $advertzone = "unzoned"; }
	if ($ENV{'QUERY_STRING'} =~ /page=([^\s&]*)/) {
		$displaypage = $1;
		$NonSSI = 1;
	}
	if ($ENV{'QUERY_STRING'} =~ /advert=([^\s&]*)/) {
		$displayad = $1;
		&gotoad;
		return;
	}
	unless ($NonSSI || $ADVNoPrint) { print "Content-type: text/html\n\n"; }
	if ($ENV{'QUERY_STRING'} =~ /ID=([^\s&]*)/) {
		$ADVID = $1;
		&CreditID;
	}
	else {
		if ($advertzone eq "ShowAll") { &ADVshowall; }
		else { &ADVdisplayad; }
	}
	if (($AdvertChosen < 1) && $DefaultBanner) {
		$ShowDefaultBanner = 1;
		&ADVdisplayad;
	}
}

sub CreditID {
	$ADVlockerror = &ADVLockFile("$ADVID.txt");
	unless ($ADVlockerror) {
		open (ADVDISPLAY, "+<$adverts_dir/$ADVID.txt");
		@ADVdisplaylines = <ADVDISPLAY>;
		($ADVratio,$ADVdisplaycount) = split (/\|/, $ADVdisplaylines[16]);
		$ADVdisplaycount++;
		unless (@ADVdisplaylines < 1) {
			seek(ADVDISPLAY, 0, 0);
			foreach $key (0..15) {
				print ADVDISPLAY "$ADVdisplaylines[$key]";
			}
			print ADVDISPLAY "$ADVratio|$ADVdisplaycount\n";
			foreach $key (17..19) {
				print ADVDISPLAY "$ADVdisplaylines[$key]";
			}
			truncate (ADVDISPLAY, tell(ADVDISPLAY));
		}
		close (ADVDISPLAY);
		&ADVUnlockFile("$ADVID.txt");
	}
	$ADVlockerror = &ADVLockFile("$ADVID.log");
	unless ($ADVlockerror) {
		if (-e "$adverts_dir/$ADVID.log") {
			open (DAILYLOG,"+<$adverts_dir/$ADVID.log");
		}
		else {
			open (DAILYLOG,">$adverts_dir/$ADVID.log");
		}
		$ADVaccess = "$ADVmday $ADVmon $ADVyear S";
		$ADVlocation = tell DAILYLOG;
		while ($ADVline = <DAILYLOG>) {
			if (($ADVacc,$ADVlogstring) = ($ADVline =~
			  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d S)$/)) {
				if ($ADVaccess eq $ADVlogstring) {
					last;
				}
			}
			last if ($ADVaccess eq $ADVlogstring);
			$ADVlocation = tell DAILYLOG;
			$ADVacc = 0;
		}
		$ADVacc++;
		seek (DAILYLOG, $ADVlocation, 0);
		$ADVlongacc = sprintf("%010.10d",$ADVacc);
		print DAILYLOG "$ADVlongacc $ADVaccess\n";
		close (DAILYLOG);
		&ADVUnlockFile("$ADVID.log");
	}
	&ADVdisplayad;
}

sub ADVdisplayad {
	if ($ShowDefaultBanner) {
		$ADVdisplayad = $DefaultBanner;
		$ADVlockerror = &ADVLockFile("adcount.txt");
		if ($ADVlockerror) { return; }
		open (ADVCOUNT, "+<$adverts_dir/adcount.txt");
		@ADVcountlines = <ADVCOUNT>;
		foreach $ADVline (@ADVcountlines) {
			chop ($ADVline) if ($ADVline =~ /\n$/);
		}
		$ADVexposures = $ADVcountlines[1];
		($ADVexposures,@ADVcycles) = split (/\|/, $ADVexposures);
		foreach $ADVcycles (@ADVcycles) {
			($ADVone,$ADVtwo) = split(/=/,$ADVcycles);
			unless ($ADVtwo) { $ADVtwo = "unzoned"; }
			$cyclecount{$ADVtwo} = $ADVone;
		}
	}
	else {
		$ADVWrapCounter++;
		$ADVlockerror = &ADVLockFile("adcount.txt");
		if ($ADVlockerror) { return; }
		if (-e "$adverts_dir/adcount.txt") {
			open (ADVCOUNT, "+<$adverts_dir/adcount.txt");
		}
		else {
			open (ADVCOUNT, ">$adverts_dir/adcount.txt");
		}
		@ADVcountlines = <ADVCOUNT>;
		if (@ADVcountlines < 2) {
			$ADVcountlines[0] = 1;
			$ADVcountlines[1] = "0";
			$ADVcountlines[2] = time;
			seek(ADVCOUNT, 0, 0);
			foreach $ADVcountline (@ADVcountlines) {
				print ADVCOUNT "$ADVcountline\n";
			}
			truncate (ADVCOUNT, tell(ADVCOUNT));
		}
		$ADVlockerror = &ADVLockFile("adlist.txt");
		if ($ADVlockerror) {
			close (ADVCOUNT);
			&ADVUnlockFile("adcount.txt");
			return;
		}
		open (ADVLIST, "+<$adverts_dir/adlist.txt");
		while ($ADVlist = <ADVLIST>) {
			push (@ADVcountlines,$ADVlist);
		}
		close (ADVLIST);
		&ADVUnlockFile("adlist.txt");
		if ((@ADVcountlines < 4)
		  || ($ADVWrapCounter > @ADVcountlines-3)) {
			close (ADVCOUNT);
			&ADVUnlockFile("adcount.txt");
			return;
		}
		foreach $ADVline (@ADVcountlines) {
			chop ($ADVline) if ($ADVline =~ /\n$/);
		}
		$ADVcount = $ADVcountlines[0];
		@ADVcount = split(/\|/,$ADVcount);
		foreach $ADVcount (@ADVcount) {
			($ADVone,$ADVtwo) = split(/=/,$ADVcount);
			unless ($ADVtwo) { $ADVtwo = "unzoned"; }
			$zonecount{$ADVtwo} = $ADVone;
		}
		unless ($zonecount{$advertzone}) { $zonecount{$advertzone} = 1; }
		$ADVexposures = $ADVcountlines[1];
		($ADVexposures,@ADVcycles) = split (/\|/, $ADVexposures);
		foreach $ADVcycles (@ADVcycles) {
			($ADVone,$ADVtwo) = split(/=/,$ADVcycles);
			unless ($ADVtwo) { $ADVtwo = "unzoned"; }
			$cyclecount{$ADVtwo} = $ADVone;
		}
		unless ($cyclecount{$advertzone}) { $cyclecount{$advertzone} = 1; }
		$ADVdisplayad = $ADVcountlines[$zonecount{$advertzone}+2];
		$ADVcycles = $cyclecount{$advertzone};
		$zonecount{$advertzone}++;
		if ($zonecount{$advertzone} > @ADVcountlines-3) {
			$zonecount{$advertzone} = 1;
			$cyclecount{$advertzone}++;
		}
		$ADVcountlines[0] = "";
		foreach $key (keys %zonecount) {
			$ADVcountlines[0] =
			  $ADVcountlines[0]."$zonecount{$key}=$key|";
		}
		if ($ADVID eq $ADVdisplayad) {
			&CloseCount;
			&ADVdisplayad;
			return;
		}
	}
	$ADVlockerror = &ADVLockFile("$ADVdisplayad.txt");
	if ($ADVlockerror) {
		unless ($ShowDefaultBanner) {
			&CloseCount;
			&ADVdisplayad;
		}
		return;
	}
	open (ADVDISPLAY, "+<$adverts_dir/$ADVdisplayad.txt");
	@ADVdisplaylines = <ADVDISPLAY>;
	foreach $ADVline (@ADVdisplaylines) {
		chop ($ADVline) if ($ADVline =~ /\n$/);
	}
	($ADVmax,$ADVshown,$ADVvisits,
	  $ADVurl,$ADVimage,$ADVheight,$ADVwidth,
	  $ADValt,$ADVpass,$ADVtext,$ADVstart,
	  $ADVweight,$ADVzone,$ADVborder,$ADVtarget,
	  $ADVraw,$ADVratio,$ADVname,$ADVemail,
	  $ADVdisplayzone) = @ADVdisplaylines;
	($ADVmax,$ADVmaxtype) = split (/\|/, $ADVmax);
	unless ($ADVmaxtype) { $ADVmaxtype = "E"; }
	($ADVdisplayratio,$ADVdisplaycount) = split (/\|/, $ADVratio);
	$ADVrealmax = $ADVmax;
	if (($ADVmaxtype eq "E") && ($ADVdisplayratio > 0)) {
		$ADVrealmax += int($ADVdisplaycount/$ADVdisplayratio);
	}
	($ADVtext,$ADVtexttype) = split (/\|/, $ADVtext);
	unless ($ADVtexttype) { $ADVtexttype = "B"; }
	if ($Ztext) { $ADVtext = $Ztext; }
	if ($Zalt) { $ADValt = $Zalt; }
	if ($Ztarget) { $ADVtarget = $Ztarget; }
	if ($Zheight) { $ADVheight = $Zheight; }
	if ($Zwidth) { $ADVwidth = $Zwidth; }
	if ($Zborder) { $ADVborder = $Zborder; }
	unless ($ShowDefaultBanner) {
		if ((($advertzone ne "unzoned") && ($advertzone ne "ShowAll")
		  && (length($ADVzone) > 2) && ($ADVzone !~ /\s$advertzone\s/))
		  || !($ADVimage || $ADVraw)
		  || ($ADVweight < 1)
		  || ((($ADVmaxtype eq "E") && ($ADVrealmax <= $ADVshown))
		  && (($ADVdisplayratio < 1) || ($advertzone ne "ShowAll")))
		  || (($ADVmaxtype eq "C") && ($ADVrealmax <= $ADVvisits))
		  || (($ADVmaxtype eq "D") && ($ADVrealmax <= $ADVtime))
		  || ($ADVstart > $ADVtime)
		  || ((($ADVcycles/$ADVweight) != int($ADVcycles/$ADVweight))
		  && ($advertzone ne "ShowAll"))) {
			&CloseCount;
			close (ADVDISPLAY);
			&ADVUnlockFile("$ADVdisplayad.txt");
			&ADVdisplayad;
			return;
		}
	}
	$ADVexposures++;
	&CloseCount;
	@ADVimage = split (/\|/,$ADVimage);
	$imagecount = @ADVimage;
	srand();
	$ADVdisplayimage = @ADVimage[int(rand($imagecount))];
	if ($NonSSI) {
		$ADVlockerror = &ADVLockFile("nonssi.log");
		if ($ADVlockerror) {
			close (ADVDISPLAY);
			&ADVUnlockFile("$ADVdisplayad.txt");
			return;
		}
		if (-e "$adverts_dir/nonssi.log") {
			open (NONSSILOG,"+<$adverts_dir/nonssi.log");
		}
		else {
			open (NONSSILOG,">$adverts_dir/nonssi.log");
		}
		@nonssi = <NONSSILOG>;
		seek(NONSSILOG, 0, 0);
		foreach $nonssiline (@nonssi) {
			($nonssitime,$other) = split(/\s/,$nonssiline);
			unless (($ADVtime-$nonssitime) > 900) {
				print NONSSILOG "$nonssiline";
			}
		}
		$ADVremote = "NA";
		if ($ENV{'REMOTE_HOST'}) {
			$ADVremote = $ENV{'REMOTE_HOST'};
		}
		print NONSSILOG "$ADVtime $ADVremote $displaypage ";
		print NONSSILOG "$advertzone | $ADVdisplayad\n";
		truncate (NONSSILOG, tell(NONSSILOG));
		close (NONSSILOG);
		&ADVUnlockFile("nonssi.log");
		print "Status: 302 Found\n";
		print "Expires: 31 Dec 97\n"; 
		print "Location: $ADVdisplayimage\n\n";
	}
	elsif ($ADVraw) {
		print "$ADVraw\n";
	}
	else {
		print "<P ALIGN=CENTER>";
		if ($ADVtext && ($ADVtexttype eq "T")
		  && ($advertzone ne "ShowAll")) {
			print "<SMALL>";
			if ($ADVurl) {
				print "<A HREF=\"$display_cgi?";
				print "advert=$ADVdisplayad\"";
				if ($ADVtarget eq "_top") {
					print " TARGET=\"$ADVtarget\"";
				}
				elsif ($ADVtarget) {
					print " $ADVtarget";
				}
				print ">";
			}
			print "$ADVtext";
			if ($ADVurl) {
				print "</A>";
			}
			print "</SMALL><BR>";
		}
		if ($ExchangeLogo) {
			if ($ExchangeURL) {
				print "<A HREF=\"$ExchangeURL\"";
				if ($ADVtarget eq "_top") {
					print " TARGET=\"$ADVtarget\"";
				}
				elsif ($ADVtarget) {
					print " $ADVtarget";
				}
				print ">";
			}
			print "<IMG SRC=\"$ExchangeLogo\"";
			if ($ExchangeLogoHeight && $ExchangeLogoWidth) {
				print " HEIGHT=$ExchangeLogoHeight";
				print " WIDTH=$ExchangeLogoWidth";
			}
			if ($ExchangeName) {
				print " ALT=\"$ExchangeName\"";
			}
			print ">";
			if ($ExchangeURL) {
				print "</A>";
			}
		}
		if ($ADVurl) {
			print "<A HREF=\"$display_cgi?advert=$ADVdisplayad\"";
			if ($ADVtarget eq "_top") {
				print " TARGET=\"$ADVtarget\"";
			}
			elsif ($ADVtarget) {
				print " $ADVtarget";
			}
			print ">";
		}
		print "<IMG SRC=\"$ADVdisplayimage\"";
		if ($ADVheight && $ADVwidth) {
			print " HEIGHT=$ADVheight WIDTH=$ADVwidth";
		}
		print " ALT=\"$ADValt\"";
		unless ($ADVborder) { $ADVborder="0"; }
		print " BORDER=$ADVborder";
		print ">";
		if ($ADVurl) {
			print "</A>";
		}
		if ($ADVtext && ($ADVtexttype eq "B")
		  && ($advertzone ne "ShowAll")) {
			print "<BR><SMALL>";
			if ($ADVurl) {
				print "<A HREF=\"$display_cgi?";
				print "advert=$ADVdisplayad\"";
				if ($ADVtarget eq "_top") {
					print " TARGET=\"$ADVtarget\"";
				}
				elsif ($ADVtarget) {
					print " $ADVtarget";
				}
				print ">";
			}
			print "$ADVtext";
			if ($ADVurl) {
				print "</A>";
			}
			print "</SMALL>";
		}
		print "</P>\n";
	}
	$ADVshown += 1;
	if ($ADVmax || $ADVratio) {
		seek(ADVDISPLAY, 0, 0);
		print ADVDISPLAY "$ADVmax|$ADVmaxtype\n";
		print ADVDISPLAY "$ADVshown\n";
		print ADVDISPLAY "$ADVvisits\n";
		print ADVDISPLAY "$ADVurl\n";
		print ADVDISPLAY "$ADVimage\n";
		print ADVDISPLAY "$ADVheight\n";
		print ADVDISPLAY "$ADVwidth\n";
		print ADVDISPLAY "$ADValt\n";
		print ADVDISPLAY "$ADVpass\n";
		print ADVDISPLAY "$ADVtext|$ADVtexttype\n";
		print ADVDISPLAY "$ADVstart\n";
		print ADVDISPLAY "$ADVweight\n";
		print ADVDISPLAY "$ADVzone\n";
		print ADVDISPLAY "$ADVborder\n";
		print ADVDISPLAY "$ADVtarget\n";
		print ADVDISPLAY "$ADVraw\n";
		print ADVDISPLAY "$ADVratio\n";
		print ADVDISPLAY "$ADVname\n";
		print ADVDISPLAY "$ADVemail\n";
		print ADVDISPLAY "$ADVdisplayzone\n";
		truncate (ADVDISPLAY, tell(ADVDISPLAY));
	}
	close (ADVDISPLAY);
	&ADVUnlockFile("$ADVdisplayad.txt");
	$AdvertChosen++;
	$ADVlockerror = &ADVLockFile("$ADVdisplayad.log");
	if ($ADVlockerror) { return; }
	if (-e "$adverts_dir/$ADVdisplayad.log") {
		open (DAILYLOG,"+<$adverts_dir/$ADVdisplayad.log");
	}
	else {
		open (DAILYLOG,">$adverts_dir/$ADVdisplayad.log");
	}
	$ADVaccess = "$ADVmday $ADVmon $ADVyear E";
	$ADVlocation = tell DAILYLOG;
	while ($ADVline = <DAILYLOG>) {
		if (($ADVacc,$ADVlogstring) = ($ADVline =~
		  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d E)$/)) {
			if ($ADVaccess eq $ADVlogstring) {
				last;
			}
		}
		last if ($ADVaccess eq $ADVlogstring);
		$ADVlocation = tell DAILYLOG;
		$ADVacc = 0;
	}
	$ADVacc++;
	seek (DAILYLOG, $ADVlocation, 0);
	$ADVlongacc = sprintf("%010.10d",$ADVacc);
	print DAILYLOG "$ADVlongacc $ADVaccess\n";
	close (DAILYLOG);
	&ADVUnlockFile("$ADVdisplayad.log");
	if ($ADVLogIP) {
		$ADVlockerror = &ADVLockFile("$ADVdisplayad.ips");
		if ($ADVlockerror) { return; }
		if (-e "$adverts_dir/$ADVdisplayad.ips") {
			open (DAILYLOG,"+<$adverts_dir/$ADVdisplayad.ips");
		}
		else {
			open (DAILYLOG,">$adverts_dir/$ADVdisplayad.ips");
		}
		@ADVips = <DAILYLOG>;
		seek(DAILYLOG, 0, 0);
		foreach $ADVline (@ADVips) {
			($ADVip,$ADVother) = split (/\s/, $ADVline);
			unless (($ADVtime-$ADVip) > 86400) {
				print DAILYLOG $ADVline;
			}
		}
		print DAILYLOG "$ADVtime - $ADVhour:$ADVmin - E - ";
		print DAILYLOG "$ENV{'REMOTE_HOST'}\n";
		truncate (DAILYLOG, tell(DAILYLOG));
		close (DAILYLOG);
		&ADVUnlockFile("$ADVdisplayad.ips");
	}
}

sub CloseCount {
	$ADVcountlines[1] = "$ADVexposures|";
	foreach $key (keys %cyclecount) {
		$ADVcountlines[1] =
		  $ADVcountlines[1]."$cyclecount{$key}=$key|";
	}
	seek(ADVCOUNT, 0, 0);
	foreach $key (0..2) {
		print ADVCOUNT "$ADVcountlines[$key]\n";
	}
	truncate (ADVCOUNT, tell(ADVCOUNT));
	close (ADVCOUNT);
	&ADVUnlockFile("adcount.txt");
}

sub ADVshowall {
	$ADVshown = 0;
	&ADVdisplayad;
	unless ((@ADVcountlines < 4)
	  || ($ADVWrapCounter > @ADVcountlines-3)) {
		&ADVshowall
	}
}

sub gotoad {
	if ($displayad eq "NonSSI") {
		$ADVlockerror = &ADVLockFile("nonssi.log");
		if ($ADVlockerror) {
			undef (@nonssi);
		}
		else {
			open (NONSSILOG,"<$adverts_dir/nonssi.log");
			@nonssi = <NONSSILOG>;
			close (NONSSILOG);
			&ADVUnlockFile("nonssi.log");
		}
		@reversenonssi = reverse (@nonssi);
		$ADVremote = "NA";
		if ($ENV{'REMOTE_HOST'}) {
			$ADVremote = $ENV{'REMOTE_HOST'};
		}
		$logcheck = "$ADVremote $displaypage $advertzone";
		foreach $nonssiline (@reversenonssi) {
			if ($nonssiline =~ /^\d* $logcheck \| (.*)$/) {
				$displayad = $1;
				last;
			}
		}
		if ($displayad eq "NonSSI") {
			&BadRef;
			return;
		}
	}
	$ADVlockerror = &ADVLockFile("$displayad.txt");
	if ($ADVlockerror) {
		&BadRef;
		return;
	}
	open (ADVDISPLAY, "+<$adverts_dir/$displayad.txt");
	@ADVdisplaylines = <ADVDISPLAY>;
	foreach $ADVline (@ADVdisplaylines) {
		chop ($ADVline) if ($ADVline =~ /\n$/);
	}
	$ADVdisplaylines[2] += 1;
	unless (@ADVdisplaylines < 1) {
		seek(ADVDISPLAY, 0, 0);
		foreach $ADVline (@ADVdisplaylines) {
			print ADVDISPLAY ("$ADVline\n");
		}
		truncate (ADVDISPLAY, tell(ADVDISPLAY));
	}
	close (ADVDISPLAY);
	&ADVUnlockFile("$displayad.txt");
	$ADVlockerror = &ADVLockFile("$displayad.log");
	unless ($ADVlockerror) {
		if (-e "$adverts_dir/$displayad.log") {
			open (DAILYLOG,"+<$adverts_dir/$displayad.log");
		}
		else {
			open (DAILYLOG,">$adverts_dir/$displayad.log");
		}
		$ADVaccess = "$ADVmday $ADVmon $ADVyear C";
		$ADVlocation = tell DAILYLOG;
		while ($ADVline = <DAILYLOG>) {
			if (($ADVacc,$ADVlogstring) = ($ADVline =~
			  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d C)$/)) {
				if ($ADVaccess eq $ADVlogstring) {
					last;
				}
			}
			last if ($ADVaccess eq $ADVlogstring);
			$ADVlocation = tell DAILYLOG;
			$ADVacc = 0;
		}
		$ADVacc++;
		seek (DAILYLOG, $ADVlocation, 0);
		$ADVlongacc = sprintf("%010.10d",$ADVacc);
		print DAILYLOG "$ADVlongacc $ADVaccess\n";
		close (DAILYLOG);
		&ADVUnlockFile("$displayad.log");
	}
	if ($ADVLogIP) {
		$ADVlockerror = &ADVLockFile("$displayad.ips");
		unless ($ADVlockerror) {
			if (-e "$adverts_dir/$displayad.ips") {
				open (DAILYLOG,"+<$adverts_dir/$displayad.ips");
			}
			else {
				open (DAILYLOG,">$adverts_dir/$displayad.ips");
			}
			@ADVips = <DAILYLOG>;
			seek(DAILYLOG, 0, 0);
			foreach $ADVline (@ADVips) {
				($ADVip,$ADVother) = split (/\s/, $ADVline);
				unless (($ADVtime-$ADVip) > 86400) {
					print DAILYLOG $ADVline;
				}
			}
			print DAILYLOG "$ADVtime - $ADVhour:$ADVmin - C - ";
			print DAILYLOG "$ENV{'REMOTE_HOST'}\n";
			truncate (DAILYLOG, tell(DAILYLOG));
			close (DAILYLOG);
			&ADVUnlockFile("$displayad.ips");
		}
	}
	print "Status: 302 Found\n"; 
	print "Location: $ADVdisplaylines[3]\n\n";
}

sub BadRef {
	print "Content-type: text/html\n\n";
	print "<HTML>";
	print "<HEAD><TITLE>WebAdverts Error!</TITLE></HEAD>\n";
	print "<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000000\">\n";
	print "<HR><H1 ALIGN=CENTER>Invalid Destination</H1><HR>\n";
	print "<P>Sorry, but the server encountered an error ";
	print "while trying to redirect you to the destination ";
	print "of the banner on which you clicked! ";
	print "The most likely cause of the problem ";
	print "is an attempt to click on a banner ";
	print "before the graphic image has loaded. ";
	print "Another possibility is that you attempted to click ";
	print "on an old banner which was reloaded ";
	print "from your browser's cache.</P>\n";
	print "<HR></BODY></HTML>\n";
}

sub ADVLockFile {
	local($lockfilename) = $_[0];
	local(*FILE) = $_[0];
	local($TrysLeft) = 10;
	if ((-M "$adverts_dir/$lockfilename.lok") > .001) {
		unlink ("$adverts_dir/$lockfilename.lok");
	}
	while ($TrysLeft--) {
		if (-f "$adverts_dir/$lockfilename.lok") {
			select(undef,undef,undef,0.1);
		}
		else {
			open (FILE,">$adverts_dir/$lockfilename.lok");
			if ($ADVUseLocking) {
				$lockresult = eval("flock(FILE,6)");
				if ($@) {
					$ADVUseLocking = 0;
					last;
				}
				if (!$lockresult) {
					close (FILE);
					unlink ("$adverts_dir/$lockfilename.lok");
					select(undef,undef,undef,0.1);
				}
				else {
					last;
				}
			}
			else {
				last;
			}
		}
	}
	if ($TrysLeft >= 0) {
		return 0;
	}
	else {
		return 1;
	}
}

sub ADVUnlockFile {
	local($lockfilename) = $_[0];
	local(*FILE) = $_[0];
	close (FILE);
	unlink ("$adverts_dir/$lockfilename.lok");
}

sub UpdateAdList {
	$ADVlockerror = &ADVLockFile("adcount.txt");
	if ($ADVlockerror) {
		&Error_File("adcount.txt");
		return;
	}
	open (ADVCOUNT, "+<$adverts_dir/adcount.txt");
	@ADVlines = <ADVCOUNT>;
	if (@ADVlines < 2) {
		$ADVlines[0] = 1;
		$ADVlines[1] = "0";
		$ADVlines[2] = time;
	}
	foreach $ADVline (@ADVlines) { chop ($ADVline) if ($ADVline =~ /\n$/); }
	seek(ADVCOUNT, 0, 0);
	print ADVCOUNT "$ADVlines[0]\n";
	print ADVCOUNT "$ADVlines[1]\n";
	print ADVCOUNT "$ADVlines[2]\n";
	$ADVmax = @ADVlines - 1;
	@advertisements = @ADVlines[3..$ADVmax];
	$ADVlockerror = &ADVLockFile("adlist.txt");
	if ($ADVlockerror) {
		foreach $advertiser (@advertisements) {
			next if (length($advertiser) < 2);
			print ADVCOUNT "$advertiser\n";
		}
		truncate (ADVCOUNT, tell(ADVCOUNT));
		close (ADVCOUNT);
		&ADVUnlockFile("adcount.txt");
		&Error_File("adlist.txt");
		return;
	}
	open (ADVLIST, ">$adverts_dir/adlist.txt");
	foreach $advertiser (@advertisements) {
		next if (length($advertiser) < 2);
		print ADVLIST "$advertiser\n";
	}
	truncate (ADVCOUNT, tell(ADVCOUNT));
	close (ADVCOUNT);
	&ADVUnlockFile("adcount.txt");
	truncate (ADVLIST, tell(ADVLIST));
	close (ADVLIST);
	&ADVUnlockFile("adlist.txt");
}

1;

