#!/usr/npac/bin/perl
# *********************************************
# Simple DBM Redirection script (public domain)
# Results display script v1.1
# by Thijs Kinkhorst <thijs@kinkhorst.com>
# *********************************************

print "Content-Type: text/html\n\n<HTML>\n";
print "<HEAD><TITLE>Redirection results</TITLE></HEAD>\n";
print "<BODY BGCOLOR=\"#FFFFFF\">\n<H1>Redirection results</H1>\n\n";

if($ENV{'REQUEST_METHOD'} eq "POST"){
	# delete urls
	read(STDIN,$in,$ENV{"CONTENT_LENGTH"});
	$in =~ s/del=//gi;
	@ts = split(/\&/,$in);
	dbmopen(%database,"redir",0600);
	foreach $disp (@ts){
		$disp =~ s/\+/ /g;
		$disp =~ s/\%(..)/chr(hex($1))/ge;
		print "Deleting $disp...";
		delete $database{$disp};
		print " done.<BR>\n";
	}
	print "</BODY></HTML>";
	dbmclose(%database);
	exit;
}

dbmopen(%database,"redir",0400);

if($ENV{'QUERY_STRING'} eq "url=All"){
	# show all
	@urls=keys(%database);
	foreach $url (@urls) {
		if($url eq ""){next}
		push(@templist,"<TD><INPUT TYPE=\"checkbox\" NAME=\"del\" VALUE=\"$url\"></TD><TD ALIGN=\"right\" BGCOLOR=\"#CCFFFF\">$database{$url}</TD><TD BGCOLOR=\"#FFFFCC\" ALIGN=\"left\"><A HREF=\"$url\">$url</A></TD></TR>\n");
	}
	@templist2 = sort {
		$a =~ /<TD><INPUT .+><\/TD><TD.+>(.*)<\/TD>.+<\/A>.*<\/TD><\/TR>.*/i;
		$tm1=$1;
		$b =~ /<TD><INPUT .+><\/TD><TD.+>(.*)<\/TD>.+<\/A>.*<\/TD><\/TR>.*/i;
		$1 <=> $tm1;
	} @templist;
	
	print "<FORM ACTION=\"redir-res.cgi\" METHOD=\"POST\">\n";
	print "<TABLE CELLPADDING=2 CELLSPACING=2>\n<TR><TH></TH><TH COLSPAN=2 BGCOLOR=\"#FFCCCC\">URLs refered</TH></TR>\n";

	print @templist2;
	print "</TABLE><BR><INPUT TYPE='submit' VALUE='Delete selected URLs'></FORM>\n</BODY></HTML>";
	exit;
}

if($ENV{'QUERY_STRING'} =~ /url=(.+)/i){
	# show one
	$url=$1;
	$url=~(s/\%(..)/chr(hex($1))/ge);
	print "<P>I have redirected <STRONG>$database{$url}</STRONG> time";
	if($database{$url} ne "1"){print "s"}
	print " to <A HREF=\"$url\">$url</A>.</P>\n</BODY></HTML>";
	exit;
}

# else...

@urls=sort(keys(%database));
close(%database);

print "<P>Please choose the URL to view the results for:</P>\n";
print "<FORM ACTION=\"redir-res.cgi\" METHOD=GET>\n<SELECT NAME=\"url\">\n";
print "<OPTION SELECTED>All\n<OPTION VALUE=\"\">----------\n";

foreach $url (@urls) {
	if($url eq ""){next}
	print "<OPTION>$url\n";
}

print "</SELECT>\n<INPUT TYPE=\"submit\" VALUE=\" View! \">\n</FORM></BODY></HTML>";
