#!/usr/local/bin/perl5 -w
#	Add Session Information to file
#
require "cgi-lib.pl";
$mailprog = '/usr/lib/sendmail';
#
$statusofread =  &ReadParse(*formdata);
$userdir = 'defaultuser';
if( $statusofread && exists($formdata{"user"}) ) {
        $userdir = $formdata{"user"} if( defined($formdata{"user"}) );
	$userdir =~ s%^([^\@]*)\@(.*)$%\1%;
}
$userdir =~ s%\s+%_%g;
$userdir =~ s%\W+%X%g;
$testuserdir = $userdir;
$testuserdir =~ tr/A-Z/a-z/;
if( ($testuserdir eq 'guest') || ($testuserdir =~ m%^anon%) )   {
        $userdir = 'defaultuser';
}
$userdir = 'defaultuser' if( $userdir ne 'gcf' );
#
#	Base URL
$basefordumping = "/usr/local/archives/public/html/users/gcf/nobody/webwisdom/";
#
$today =`date`;
chomp($today);
#
$basefordumping .= $userdir .'/edit/';
#
$sessionfile='errorlog';
if( $statusofread )     {
	$sessionfile = $formdata{'session'};
	$sessionfile =~ s%\s+%_%g;
	$sessionfile =~ s%\W+%X%g;
}
#
$filetodumpto = $basefordumping . $sessionfile;
#
$count = 0;
while (!&LockDatabase($filetodumpto)) { # Sleep for a second
        sleep(1);
        ++$count;
        &therewaserror("Server out to lunch -- please email -- lock stuck") if($count > 20);
}
#
#
$dumperrorflag=0;
if(-e $filetodumpto )	{
	open(FILETODUMPTO,'>>'.$filetodumpto) || ($dumperrorflag=1);
}
else	{
	open(FILETODUMPTO,'>'.$filetodumpto) || ($dumperrorflag=2);
}
if( $dumperrorflag > 0 )	{
	print "Location: http://boss.npac.syr.edu:8080/webwisdom/editutilities/SessionDumpError.html\n\n";
	&UnlockDatabase($filetodumpto);
	exit 1;
}
#
print FILETODUMPTO "sessionstart:$today\n";
print FILETODUMPTO "address:$ENV{'REMOTE_ADDR'}\nsessionhost:$ENV{'REMOTE_HOST'}\n";
#
if( $statusofread )	{
	foreach $mem (sort keys %formdata)	{
		next	if( $mem =~ m%^CHG% );
		if( $mem ne 'typeofform' )	{
			next unless(exists($formdata{'CHG'.$mem}));
			my($testval) = $formdata{'CHG'.$mem};
			next if($testval =~ m%^n%i );
		}
		$val = $formdata{$mem};
		next if( $val eq 'UNSET' );
		next if( $val eq 'UNIMPLEMENTED' );
		next if( $val eq 'Replace with Text' );
		$val =~ s%[\n\r\f]+%\nCONTD:%gs;
		$val =~ s%\nCONTD:$%%s;
		print FILETODUMPTO "$mem:$val\n";
	}
}
else	{
	$dumperrorflag=3;
	print FILETODUMPTO "Error:3\n";
}
print FILETODUMPTO "sessionend:$today\n";
close(FILETODUMPTO);
#
&UnlockDatabase($filetodumpto);
#
if( $dumperrorflag > 0 )	{
	print "Location: http://boss.npac.syr.edu:8080/webwisdom/editutilities/SessionDumpError.html\n\n";
}
else	{
	print "Location: http://boss.npac.syr.edu:8080/webwisdom/editutilities/SessionDumpOK.html\n\n";
}
sub therewaserror       {

        my($mess) = @_;
#
        print <<EOF;
Content-Type: text/html

<html>
<head>
<title>Error in savesession.pl Processing!</title>
</head>
<h2>Error in Processing URL Logging: $mess</H2>
Please correct or if it's our fault
<A HREF="mailto:gcf\@npac.syr.edu?subject=savesession.pl Lock Error $mess" onMouseOver="window.status=' Sadness!.';return true">Mail Complaint</A>
<hr>
EOF
	exit;
}
sub LockDatabase {
# PURPOSE: Attempt to "lock" the database by creating a lock file.
# INPUTS:  Database file name
# OUTPUTS: A boolean telling if the lock was successful

        my ($dbfile) = @_;

        if (-e "$dbfile.lock") {  # DB is already locked
                return 0;
        }
        else {
                system("touch $dbfile.lock");  # Create the lock file
                return 1;
        }
}

sub UnlockDatabase {
# PURPOSE: Attempt to "unlock" the database by deleting the lock file.
# INPUTS:  Database file name
# OUTPUTS: None (but should probably check that the unlock was successful)

        my ($dbfile) = @_;
        unless( (unlink("$dbfile.lock")) )      {
                open (MAIL, "|$mailprog gcf") || (&therewaserror("Server Error Can't Mail -- Please email us")) ;
                print MAIL <<EOF;
From:gcf
To:gcf
Subject:Error in unlink
------------------------------------------------------

Please check savesession.pl
$ENV{'REMOTE_ADDR'} $ENV{'REMOTE_HOST'},
$formdata{"user"}
$formdata{"session"}
$sessionfile
$userdir
DUMP Error Indicator $dumperrorflag
$today
EOF
                close(MAIL);
        }
}
#
#
1;

